Summary:	Object system, widget set and GUI builder for Tcl
Name:		classytk
Version:	1.0.0
Release:	1
Copyright:	BSD
Group:	Development/Languages/Tcl
Source:	ClassyTk-1.0.0.src.tar.gz
URL: http://rrna.uia.ac.be/classytcl
Packager: Peter De Rijk <derijkp@uia.ua.ac.be>
Requires: tcl >= 8.3.2 extral >= 2.0.0 classytcl >= 1.0.0
Prefix: /usr/lib /usr/bin
%description

Gui Builder

The ClassyTk Builder can be used to graphically create interfaces. It is
invoked via the cbuild command in the bin directory.

Widget Set

ClassyTk is a widget set based on the ClassyTcl object system.
ClassyTk adds a lot of improvements to Tk, ranging from drag and drop
support (between Tk apps) and a configuration system to a large set of new
widgets and commands, written using the object system. (see further)
While the object system itself only requires Tcl (>8.0), the widgets that
come with it require Tk (of course), and another freely available extension
called ExtraL. ExtraL also does not require compiled code, but can be
speeded up by having it available. Documentation for the widgets is often
somewhat limited, but besides the documentation, you can learn a lot from
sources, the tests and the demos.

%prep
%setup -n ClassyTk
%build
cd build
./configure --prefix=/usr

%install
rm -rf /usr/lib/ClassyTk-Linux-$RPM_PACKAGE_VERSION/ /usr/doc/ClassyTk-$RPM_PACKAGE_VERSION
cd build
make install
rm -rf /usr/doc/classytk-$RPM_PACKAGE_VERSION
mkdir /usr/doc/classytk-$RPM_PACKAGE_VERSION
ln -s /usr/lib/ClassyTk1.0/help /usr/doc/classytk-$RPM_PACKAGE_VERSION/help
ln -s /usr/lib/ClassyTk1.0/README /usr/doc/classytk-$RPM_PACKAGE_VERSION/README
ln -s /usr/lib/ClassyTk1.0/CHANGES /usr/doc/classytk-$RPM_PACKAGE_VERSION/CHANGES

%files
/usr/lib/ClassyTk1.0
/usr/bin/cbuild
/usr/bin/cbuild.tcl
/usr/bin/cconvert0.1_to_0.2
/usr/bin/cconvert0.1_to_0.2.tcl
/usr/bin/ccalc
/usr/bin/ccenter
/usr/bin/cdraw
/usr/bin/cedit
/usr/bin/cfiles
/usr/bin/ctester
/usr/doc/classytk-1.0.0
