#
# ClassyTk Widgets 
# ----------------- Peter De Rijk
#
# busy command
# ----------------------------------------------------------------------

proc ::Classy::busy {{action {add}} args} {
	switch $action {
		remove {
			if ![info exists ::Classy::busy] return
			if {"$args"==""} {
				set args .
			}
			foreach p $args {
				if {"$p"=="."} {
					set pattern $p*,c
				} else {
					set pattern $p.*,c
				}
				set list [lsort -decreasing [array names ::Classy::busy $pattern]]
				list_addnew list $p,c
				foreach w $list {
					regexp {^(.*),c$} $w temp w
					if [info exists ::Classy::busy($w,c)] {
						if [winfo exists $w] {
							$w configure -cursor $::Classy::busy($w,c)
						}
						unset ::Classy::busy($w,c)
					}
					if [info exists ::Classy::busy($w,bt)] {
						if [winfo exists $w] {
							bindtags $w $::Classy::busy($w,bt)
						}
						unset ::Classy::busy($w,bt)
					}
				}
				if [info exists ::Classy::busy([winfo parent $p],c)] {
					if {"[$p cget -cursor]"==""} {
						$p configure -cursor arrow
						set ::Classy::busy($p,c) {}
					}
				}
			}
			update idletasks
		}
		default {
			update idletasks
			if [regexp {^\.} $action] {list_unshift args $action;set action add}
			if {"$action"!="add"} {
				error "Unkown action $action: should be one of add, remove or status"
			}
			if {"$args"==""} {
				set args .
			}
			foreach p $args {
				if [string_equal $p .] {
					set pattern $p*
				} elseif ![catch {winfo id $p}] {
					set pattern $p.*
					if ![info exists ::Classy::busy($p,c)] {
						set ::Classy::busy($p,c) [$p cget -cursor]
						$p configure -cursor watch
					}
					if ![info exists ::Classy::busy($p,bt)] {
						set ::Classy::busy($p,bt) [bindtags $p]
						bindtags $p none
					}
				}
				foreach w [lsort [info commands $pattern]] {
					if [catch {winfo id $w}] continue
					if ![info exists ::Classy::busy($w,c)] {
						set ::Classy::busy($w,c) [$w cget -cursor]
						$w configure -cursor watch
					}
					if ![info exists ::Classy::busy($w,bt)] {
						set ::Classy::busy($w,bt) [bindtags $w]
						bindtags $w none
					}
				}
			}
			update idletasks
		}
	}
}

