#
# ClassyTk Widgets 
# ----------------- Peter De Rijk
#
# HTML
# ----------------------------------------------------------------------
#doc HTML title {
#HTML
#} index {
# New widgets
#} shortdescr {
# displays HTML
#} descr {
# subclass of <a href="Widget.html">Widget</a><br>
# creates a HTML display widget. 
# The HTML class is based on the <a href="http://www.hwaci.com/sw/tkhtml/">html 
# widget by D. Richard Hipp</a> if present as a loadable package. It understands 
# HTML 3.2. Forms support is not incorporated yet. 
# If the compiled html widget is not found, ClassyTk reverts to the Tcl-only html 
# library by Stephen Uhler</a> that understands HTML 2.0. 
# The HTML class adds things such as asyncronous transfers and history.
#}
#doc {HTML options} h2 {
#	HTML specific options
#}
#doc {HTML command} h2 {
#	HTML specific methods
#}

Widget subclass Classy::HTML

if ![catch {package require Tkhtml}] {
	if [llength [info commands html]] {
		Classy::HTML private type tkhtml
		set ::Classy::tkhtmllib 1
	} else {
		Classy::HTML private type htmllib
		set ::Classy::tkhtmllib 0
	}
} else {
	Classy::HTML private type htmllib
	set ::Classy::tkhtmllib 0
}

if $::Classy::tkhtmllib {
	source [file join $::Classy::dir widgets HTML-tkhtml.tcl]
} else {
	source [file join $::Classy::dir widgets HTML-htmllib.tcl]
}
