#
# ClassyTk Widgets 
# ----------------- Peter De Rijk
#
# Classy::Message
# ----------------------------------------------------------------------
#doc Message title {
#Message
#} index {
# Tk improvements
#} shortdescr {
# slightly improved message widget
#} descr {
# subclass of <a href="Widget.html">Widget</a><br>
# The ClassyTk Message has all the options and commands of the Tk Message, but
# it automatically adapts its width.
#}
#doc {Message options} h2 {
#	Message specific options
#}
#doc {Message command} h2 {
#	Message specific methods
#}

bind Classy::Message <Configure> {
	%W redraw
}

# ------------------------------------------------------------------
#  Widget creation
# ------------------------------------------------------------------

Widget subclass Classy::Message

Classy::Message method init {args} {
	super init message
	if {"$args" != ""} {eval $object configure $args}
	return $object
}

# ------------------------------------------------------------------
#  Widget options
# ------------------------------------------------------------------

Classy::Message chainoptions {$object}

# ------------------------------------------------------------------
#  Methods
# ------------------------------------------------------------------

Classy::Message chainallmethods {$object} message

Classy::Message method redraw {} {
	set w [Classy::window $object]
	$w configure -width [expr [winfo width $object] - 2*[$w cget -bd]]
}

